function BW = imbinarize(varargin)
  
  #Check I inputs
   Method='global';
   if (nargin == 0)
       error (usage());
    else
      % validate the input image
      I=varargin{1};
      if (!isgray(I))
        error("imbinarize: The input I must be a gray image\n");
      endif
   end
       
   if  nargin>2 && isnumeric(varargin{2})
       error (usage());
   elseif nargin==2 && isnumeric(varargin{2})
       BW=Tthreshold(I,varargin{2});
       return;
   elseif nargin>1
       Method=varargin{2};
       switch Method
       case 'global'
         if nargin>2
            error (usage());
         end
          BW=im2bw(I);
   case 'adaptive'
     T = adaptthresh(I,varargin{3:end});
     BW=Tthreshold(I,T);
         
     otherwise
       error (usage());
       end
   endif
   
 


end

%------------------------------------------------------------------------
function msg=usage ()
  line1="imbinarize: Invalid call to multithresh.  Correct usage is\n";
  line2=" -- Function File: BW = imbinarize(I)\n ";
  line3=" -- Function File: BW = imbinarize(I,'global')\n ";
  line4=" -- Function File: BW = imbinarize(I,'adaptive',Options)\n ";
  line5=" -- Function File: BW = imbinarize(I,T)\n ";
  msg=[line1,line2,line3,line4,line5,"\n"];
endfunction
%------------------------------------------------------------------------
function WB=Tthreshold(I,T)
  % check if T has the same size as I
  if !isequal(size(I),size(T))
    error (["imbinarize: The threshold T image must have the same size as I\n",usage()]);
  end
   WB=0*I;
   I=im2double(I);
   WB(I>T)=255; 
  
end
